﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using Yeex.Boss.Web.Helper;

namespace HanhuaMicroCredit.Admin.Controllers
{
    public abstract class BaseController : Controller
    {
        /// <summary>
        /// 显示提示信息
        /// </summary>
        /// <param name="message"></param>
        public virtual void ShowMessage(string message)
        {
            TempData["__RESULT_MSG__"] = message;
        }
    }

    /// <summary>
    /// 需要登录之后才能访问
    /// </summary>
    [NeedLogin]
    public abstract class NeedLoginController : BaseController
    {
    }

    /// <summary>
    /// 需要登录并有权限才可以访问
    /// </summary>
    [NeedLevel]
    public abstract class NeedLevelController : BaseController
    {
    }

    ///// <summary>
    ///// 订单块区页面，需要登录并且有相应的权限才可以访问
    ///// </summary>
    //[OrderLevel]
    //public abstract class OrderLevelController : BaseController
    //{ 
    //}
}
